VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "mscomm32.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   6420
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7995
   LinkTopic       =   "Form1"
   ScaleHeight     =   6420
   ScaleWidth      =   7995
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      Height          =   3855
      Left            =   1200
      MultiLine       =   -1  'True
      TabIndex        =   0
      Text            =   "OwTemp.frx":0000
      Top             =   240
      Width           =   3615
   End
   Begin VB.Timer Timer1 
      Interval        =   100
      Left            =   360
      Top             =   1080
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   240
      Top             =   240
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Dim InData As String
Dim RomList() As String
Dim Temperature() As Double
Dim NumRoms As Long
Dim RomID(8) As Integer
Dim ScratchPad(9) As Integer


Private Sub Form_Load()
    MSComm1.CommPort = 1            'change to correct port number
    MSComm1.PortOpen = True
    ReDim RomList(1)
    ReDim Temperature(1)
End Sub

Private Sub Form_Unload(Cancel As Integer)
    MSComm1.PortOpen = False
End Sub

Private Sub Timer1_Timer()
Dim Record As String
    InData = InData + MSComm1.Input
    If InStr(InData, Chr(10)) Then                  'complete record received
        Record = Left(InData, InStr(InData, Chr(13)))
        'Debug.Print Record
        InData = Right(InData, Len(InData) - Len(Record) - 1)
    End If
    If Len(Record) <> 36 Then Exit Sub              'must have errored
    For x = 0 To 7                                  'convert ROM code to decimal
        RomID(x) = "&h" & Mid(Record, 1 + 2 * x, 2)
    Next x
    For x = 0 To 8                                  'convert scratchpad to decimal
        ScratchPad(x) = "&h" & Mid(Record, 18 + 2 * x, 2)
    Next x
    If CheckCRC() Then
        found = False
        For x = 1 To NumRoms
            If Left(Record, 16) = RomList(x) Then
                found = True
                Rom = x
            End If
        Next x
        If Not found Then
            If NumRoms = UBound(RomList) Then
                ReDim Preserve RomList(NumRoms + 1)
                ReDim Preserve Temperature(NumRoms + 1)
            End If
            NumRoms = NumRoms + 1
            Rom = NumRoms
            RomList(NumRoms) = Left(Record, 16)
        End If
        Temperature(Rom) = (CInt("&h" & Mid(Record, 20, 2) & Mid(Record, 18, 2))) / 2
        UpdateList Rom
    End If
        
End Sub

Sub UpdateList(RomNum)
    Text1.Text = ""
    For x = 1 To NumRoms
        Text1.Text = Text1.Text & RomList(x) & Chr(9) & Temperature(x)
        If x = RomNum Then Text1.Text = Text1.Text + " <--"
        Text1.Text = Text1.Text & vbCrLf
    Next x
End Sub

Function CheckCRC() As Boolean
    CheckCRC = False
    crc = 0
    For x = 7 To 1 Step -1
        crc = CalcCRC(crc, RomID(x))
    Next x
    If crc <> RomID(0) Then Exit Function
    crc = 0
    For x = 0 To 7
        crc = CalcCRC(crc, ScratchPad(x))
    Next x
    If crc <> ScratchPad(8) Then Exit Function
    CheckCRC = True
End Function

Function CalcCRC(crc, num)
        temp = 0
        crc = crc Xor num
        If (crc And 1) Then temp = temp Xor &H5E
        If (crc And 2) Then temp = temp Xor &HBC
        If (crc And 4) Then temp = temp Xor &H61
        If (crc And 8) Then temp = temp Xor &HC2
        If (crc And 16) Then temp = temp Xor &H9D
        If (crc And 32) Then temp = temp Xor &H23
        If (crc And 64) Then temp = temp Xor &H46
        If (crc And 128) Then temp = temp Xor &H8C
        CalcCRC = temp
End Function
